# coding: utf-8

"""
    Metal API

    # Introduction Equinix Metal provides a RESTful HTTP API which can be reached at <https://api.equinix.com/metal/v1>. This document describes the API and how to use it.  The API allows you to programmatically interact with all of your Equinix Metal resources, including devices, networks, addresses, organizations, projects, and your user account. Every feature of the Equinix Metal web interface is accessible through the API.  The API docs are generated from the Equinix Metal OpenAPI specification and are officially hosted at <https://metal.equinix.com/developers/api>.  # Common Parameters  The Equinix Metal API uses a few methods to minimize network traffic and improve throughput. These parameters are not used in all API calls, but are used often enough to warrant their own section. Look for these parameters in the documentation for the API calls that support them.  ## Pagination  Pagination is used to limit the number of results returned in a single request. The API will return a maximum of 100 results per page. To retrieve additional results, you can use the `page` and `per_page` query parameters.  The `page` parameter is used to specify the page number. The first page is `1`. The `per_page` parameter is used to specify the number of results per page. The maximum number of results differs by resource type.  ## Sorting  Where offered, the API allows you to sort results by a specific field. To sort results use the `sort_by` query parameter with the root level field name as the value. The `sort_direction` parameter is used to specify the sort direction, either either `asc` (ascending) or `desc` (descending).  ## Filtering  Filtering is used to limit the results returned in a single request. The API supports filtering by certain fields in the response. To filter results, you can use the field as a query parameter.  For example, to filter the IP list to only return public IPv4 addresses, you can filter by the `type` field, as in the following request:  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/projects/id/ips?type=public_ipv4 ```  Only IP addresses with the `type` field set to `public_ipv4` will be returned.  ## Searching  Searching is used to find matching resources using multiple field comparissons. The API supports searching in resources that define this behavior. Currently the search parameter is only available on devices, ssh_keys, api_keys and memberships endpoints.  To search resources you can use the `search` query parameter.  ## Include and Exclude  For resources that contain references to other resources, sucha as a Device that refers to the Project it resides in, the Equinix Metal API will returns `href` values (API links) to the associated resource.  ```json {   ...   \"project\": {     \"href\": \"/metal/v1/projects/f3f131c8-f302-49ef-8c44-9405022dc6dd\"   } } ```  If you're going need the project details, you can avoid a second API request.  Specify the contained `href` resources and collections that you'd like to have included in the response using the `include` query parameter.  For example:  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=projects ```  The `include` parameter is generally accepted in `GET`, `POST`, `PUT`, and `PATCH` requests where `href` resources are presented.  To have multiple resources include, use a comma-separated list (e.g. `?include=emails,projects,memberships`).  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=emails,projects,memberships ```  You may also include nested associations up to three levels deep using dot notation (`?include=memberships.projects`):  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=memberships.projects ```  To exclude resources, and optimize response delivery, use the `exclude` query parameter. The `exclude` parameter is generally accepted in `GET`, `POST`, `PUT`, and `PATCH` requests for fields with nested object responses. When excluded, these fields will be replaced with an object that contains only an `href` field. 

    The version of the OpenAPI document: 1.0.0
    Contact: support@equinixmetal.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

import equinix_metal
from equinix_metal.api.devices_api import DevicesApi  # noqa: E501
from equinix_metal.rest import ApiException


class TestDevicesApi(unittest.TestCase):
    """DevicesApi unit test stubs"""

    def setUp(self):
        self.api = equinix_metal.api.devices_api.DevicesApi()  # noqa: E501

    def tearDown(self):
        pass

    def test_create_bgp_session(self):
        """Test case for create_bgp_session

        Create a BGP session  # noqa: E501
        """
        pass

    def test_create_device(self):
        """Test case for create_device

        Create a device  # noqa: E501
        """
        pass

    def test_create_ip_assignment(self):
        """Test case for create_ip_assignment

        Create an ip assignment  # noqa: E501
        """
        pass

    def test_delete_device(self):
        """Test case for delete_device

        Delete the device  # noqa: E501
        """
        pass

    def test_find_bgp_sessions(self):
        """Test case for find_bgp_sessions

        Retrieve all BGP sessions  # noqa: E501
        """
        pass

    def test_find_device_by_id(self):
        """Test case for find_device_by_id

        Retrieve a device  # noqa: E501
        """
        pass

    def test_find_device_customdata(self):
        """Test case for find_device_customdata

        Retrieve the custom metadata of an instance  # noqa: E501
        """
        pass

    def test_find_device_metadata_by_id(self):
        """Test case for find_device_metadata_by_id

        Retrieve metadata  # noqa: E501
        """
        pass

    def test_find_device_userdata_by_id(self):
        """Test case for find_device_userdata_by_id

        Retrieve userdata  # noqa: E501
        """
        pass

    def test_find_instance_bandwidth(self):
        """Test case for find_instance_bandwidth

        Retrieve an instance bandwidth  # noqa: E501
        """
        pass

    def test_find_ip_assignment_customdata(self):
        """Test case for find_ip_assignment_customdata

        Retrieve the custom metadata of an IP Assignment  # noqa: E501
        """
        pass

    def test_find_ip_assignments(self):
        """Test case for find_ip_assignments

        Retrieve all ip assignments  # noqa: E501
        """
        pass

    def test_find_organization_devices(self):
        """Test case for find_organization_devices

        Retrieve all devices of an organization  # noqa: E501
        """
        pass

    def test_find_organization_devices_all_pages(self):
        """Test case for find_organization_devices_all_pages

        Retrieve all devices of an organization  # noqa: E501
        """
        pass

    def test_find_project_devices(self):
        """Test case for find_project_devices

        Retrieve all devices of a project  # noqa: E501
        """
        pass

    def test_find_project_devices_all_pages(self):
        """Test case for find_project_devices_all_pages

        Retrieve all devices of a project  # noqa: E501
        """
        pass

    def test_find_traffic(self):
        """Test case for find_traffic

        Retrieve device traffic  # noqa: E501
        """
        pass

    def test_get_bgp_neighbor_data(self):
        """Test case for get_bgp_neighbor_data

        Retrieve BGP neighbor data for this device  # noqa: E501
        """
        pass

    def test_get_device_firmware_sets(self):
        """Test case for get_device_firmware_sets

        Get Device's associated Firmware Set  # noqa: E501
        """
        pass

    def test_get_device_health_rollup(self):
        """Test case for get_device_health_rollup

        Get Device's Health Status  # noqa: E501
        """
        pass

    def test_perform_action(self):
        """Test case for perform_action

        Perform an action  # noqa: E501
        """
        pass

    def test_update_device(self):
        """Test case for update_device

        Update the device  # noqa: E501
        """
        pass


if __name__ == '__main__':
    unittest.main()
